#include "entities/conveyor.h"

#include "items/item.h"
#include "map/map.h"

#include <iostream>

namespace entity {

void Conveyor::update(double dt) {
    // std::cout << Map::instance().at({0, 0}).pos() << std::endl;
    if(m_has_item) {
        if(m_progress >= 1.0) {
            m_progress = 1.0;
            auto pos = node().pos();
            auto &next_belt_node = Map::instance().at(pos + Vector2<int>(1, 0));
            auto *item_sink = dynamic_cast<ItemSink *>(&next_belt_node.entity());

            if(item_sink && item_sink->can_accept(*m_item)) {
                std::cout << "accepted!" << std::endl;
                item_sink->insert(*m_item);
                m_has_item = false;
            }
            // std::cout << item_sink << ", " << item_sink->can_accept(m_item);
        } else {
            m_progress += 1.0 * dt;
        }

        std::cout << "progress: " << m_progress << std::endl;
    }
}

bool Conveyor::can_accept(Item &item) {
    // We dont care what item yet
    (void)item;

    return !m_has_item;
}

void Conveyor::insert(Item &item) {
    m_has_item = true;
    m_progress = 0.0;
    m_item = &item;
}

}  // End namespace entity

