#include "entities/entity.h"
#include "interfaces/itemsink.h"
#include "map/node.h"

namespace entity {

class Conveyor : public Entity, public ItemSink {
    public:
        Conveyor() : Entity(5) { std::cout << "Conveyor construct" << std::endl; }

        Conveyor(const Conveyor &other) = default;
        Conveyor &operator=(const Conveyor &other) = default;

        virtual ~Conveyor() = default; //{ std::cout << "Conveyor destruct" << std::endl; }

        virtual Conveyor *clone() { return new Conveyor(*this); }

        void update(double dt) override;

        bool can_accept(Item &item) override;
        void insert(Item &item) override;

        bool has_item() { return m_has_item; }
        float progress() { return m_progress; }
        Item &item() { return *m_item; }

    private:
        bool m_has_item = false;
        float m_progress = 0.0;

        Item *m_item;
};

}  // End namespace entity

