#pragma once

#include <iostream>

#include "util/render.h"

class Item {
    public:
        Item() : Item(-1) {}
        Item(int id) : m_id(id) {}

        Item(const Item &other) = default;
        Item &operator=(const Item &other) = default;

        virtual ~Item() = default;

        // virtual Item *clone() { return new Item(*this); }

        int id() { return m_id; }

        virtual void render(Render r);

        friend std::ostream &operator<<(std::ostream &os, const Item &item);
        friend std::istream &operator>>(std::istream &is, Item &item);

    private:
        int m_id;
};

