#include "map/generator.h"
#include "tiles/dirt.h"
#include "tiles/grass.h"
#include "tiles/stone.h"

Generator::Generator() {
    // set_seed(420);
}

void Generator::generate(Vector2<int> pos, Region &region) {
    for(int y = 0; y < REGION_SIZE; y++) {
        for(int x = 0; x < REGION_SIZE; x++) {
            auto world_pos = pos * REGION_SIZE + Vector2<int>(x, y);
            double noise = m_noise.accumulatedOctaveNoise2D_0_1(
                world_pos.x() / 64.0,
                world_pos.y() / 64.0,
                5
            );

            Tile *tile;
            if(noise > 0.85) {
                tile = new Stone();
            } else if(noise > 0.3) {
                tile = new Grass();
            } else {
                tile = new Dirt();
            }
            region.at({x, y}).set_tile(tile);
        }
    }
}
