#include "tiles/conveyor.h"
#include "items/wrench.h"
#include "entities/conveyor.h"

Entity *Conveyor::create_entity() {
    return new entity::Conveyor();
}

void Conveyor::render(Render r) {
    auto &entity = (entity::Conveyor &)node().entity();
    r.push_matrix();
    r.translate(node().pos() * (TILE_SIZE + 1));
    r.fill_rectangle_sz(
        node().size() * TILE_SIZE,
        {0, (int)(entity.progress() * 255.0), 255 - (int)((entity.progress() * 255.0))}
    );

    if(entity.has_item()) {
        auto pos = Vector2<float>(entity.progress() - 1.0, 0) * (TILE_SIZE + 1);
        r.translate(pos);
        entity.item().render(r);
    }
    r.pop_matrix();
}

