#include "tiles/tile.h"
#include "map/node.h"
#include "entities/rainbow.h"

Entity *Tile::create_entity() {
    // std::cout << "Tile " << id() << " did not override create_entity, it is boring..." << std::endl;
    return nullptr;
}

void Tile::render(Render r) {
    r.translate(node().pos() * (TILE_SIZE + 1));
    r.rectangle_sz(
        node().size() * TILE_SIZE,
        {255, 0, 0}
    );
}

std::ostream &operator<<(std::ostream &os, const Tile &tile) {
    Color tmp;
    os.write(reinterpret_cast<const char *>(&tile.m_id), sizeof(tile.m_id));
    os.write(reinterpret_cast<const char *>(&tmp), sizeof(tmp));

    return os;
}

std::istream &operator>>(std::istream &is, Tile &tile) {
    (void)tile;
    Color tmp;
    is.read(reinterpret_cast<char *>(&tmp), sizeof(tmp));

    return is;
}

